#ifndef OM_MULTIPLE_INHERITANCE_H_
#define OM_MULTIPLE_INHERITANCE_H_

#include "om-port.h"

namespace om_ns_mi{
 class CParent_a {
 public:
  CParent_a ():iparent_ (10) {}
  virtual void f() { cout << "CParent_a::f()" << endl; }
  virtual void g() { cout << "CParent_a::g()" << endl; }
  virtual void h() { cout << "CParent_a::h()" << endl; }
  int iparent_;
 };

 class CParent_b {
 public:
  CParent_b ():iparent_ (20) {}
  virtual void f() { cout << "CParent_a::f()" << endl; }
  virtual void g() { cout << "CParent_a::g()" << endl; }
  virtual void h() { cout << "CParent_a::h()" << endl; }
  int iparent_;
 };

 class CChild_m : public CParent_a,public CParent_b {
  public:
   CChild_m() : ichild_(1020){}
   virtual void f() { cout << "CChild::f()" << endl; }
   virtual void g() { cout << "CChild::g()" << endl; }
   int ichild_;
 };

 void TestMutipleInheritance(){

  cout << "                        Test Multiple Inheritance                            "<<endl;
  cout << "***************************************************************************" <<endl;

  int i = 0;
  Ptr_Void_Fun pFun = NULL;
  int** pVTable = NULL;

  CChild_m cc;
  pVTable = (int**)&cc;
  cout << "size: " << sizeof(cc) << endl;
  cout << (int*)&pVTable[0] << "\t" << "[0] CChild_m::CParent_a::vfptr->" << endl;

#if defined(OM_COMPILER_MSVC_)
   for (i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL; i++) {
    pFun = (Ptr_Void_Fun)pVTable[0][i];
    cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
    pFun();
   }
#else
  for (i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL && pVTable[2][i] > -100 && pVTable[2][i] < 100; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   pFun();
  }
  cout << "\t\t\t["<<i<<"] " << "\t" << &pVTable[0][i] << "\t" <<(int)pVTable[0][i] << endl;
#endif

  cout << (int*)&pVTable[1] << "\t" << "[1] CParent_a.iparent_ = " << (int)pVTable[1] << endl;

  cout << (int*)&pVTable[2] << "\t" << "[0] CChild_m::CParent_b::vfptr->" << endl;
  for (int i = 0; (Ptr_Void_Fun)pVTable[2][i] != NULL; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[2][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[2][i];
   pFun();
  }
  cout << (int*)&pVTable[3] << "\t" << "[3] CParent_a.iparent_ = " << (int)pVTable[3] << endl;
  cout << (int*)&pVTable[4] << "\t" << "[4] CChild_m.ichild_ = " << (int)pVTable[4] << endl;
 }
}

#endif
