#ifndef OM_TRIPLE_INHERITANCE_H_
#define OM_TRIPLE_INHERITANCE_H_

// ̳ϵ

#include "om-port.h"

namespace om_ns_ti{
 class CParent {
 public:
  CParent ():iparent_ (10) {}
  virtual void f() { cout << "CParent::f()" << endl; }
  virtual void g() { cout << "CParent::g()" << endl; }
  virtual void h() { cout << "CParent::h()" << endl; }
  virtual void c() { cout << "CParent::c()" << endl;}
  int iparent_;
 };
 class CChild_a : public CParent {
 public:
  CChild_a():ichild_(100) {}
  virtual void f() { cout << "CChild_a::f()" << endl; }
  virtual void g1() { cout << "CChild_a::g1()" << endl; }
  virtual void h1() { cout << "CChild_a::h1()" << endl; }
  virtual void g() { cout << "CChild_a::g()" << endl; }
  int ichild_;
 };
 class CChild_b : public CParent {
 public:
  CChild_b():ichild_(200) {}
  virtual void f() { cout << "CChild_b::f()" << endl; }
  virtual void g1() { cout << "CChild_b::g1()" << endl; }
  virtual void h1() { cout << "CChild_b::h1()" << endl; }
  int ichild_;
 };
 class CGrandChild : public CChild_a,public CChild_b{
 public:
  CGrandChild():igrandchild_(1000) {}
  virtual void f()  { cout << "CGrandChild::f()" << endl; }
  virtual void g1() { cout << "CGrandChild::g1()" << endl; }
  virtual void h2() { cout << "CGrandChild::h2()" << endl; }
  virtual void c()  { cout << "CGrandChild::c()" << endl;}
  virtual void g()  { cout << "CGrandChild::g()" << endl; }
  int igrandchild_;
 };

 class CChild_av : virtual public CParent {
 public:
  CChild_av():ichild_(100) {}
  virtual void f() { cout << "CChild_av::f()" << endl; }
  virtual void g1() { cout << "CChild_av::g1()" << endl; }
  virtual void h1() { cout << "CChild_av::h1()" << endl; }
  virtual void g() { cout << "CChild_av::g()" << endl; }
  int ichild_;
 };
 class CChild_bv : virtual public CParent {
 public:
  CChild_bv():ichild_(200) {}
  virtual void f() { cout << "CChild_bv::f()" << endl; }
  virtual void g1() { cout << "CChild_bv::g1()" << endl; }
  virtual void h1() { cout << "CChild_bv::h1()" << endl; }
  int ichild_;
 };
 class CGrandChild_v : public CChild_av,public CChild_bv{
 public:
  CGrandChild_v():igrandchild_(1000) {}
  virtual void f()  { cout << "CGrandChild_v::f()" << endl; }
  virtual void g1() { cout << "CGrandChild_v::g1()" << endl; }
  virtual void h2() { cout << "CGrandChild_v::h2()" << endl; }
  virtual void c()  { cout << "CGrandChild_v::c()" << endl;}
  //virtual void g()  { cout << "CGrandChild_v::g()" << endl; }
  int igrandchild_;
 };

 void TestTripleInheritance() {
  cout << "                        Test Triple Inheritance                            "<<endl;
  cout << "***************************************************************************" <<endl;

  int i = 0;
  Ptr_Void_Fun pFun = NULL;
  int** pVTable = NULL;

  cout << endl << "--------------- Test CGrandChild" << endl;
  CGrandChild cgc;
  pVTable = (int**)&cgc;
  cout << "size: " << sizeof(cgc) << endl;
  cout << (int*)&pVTable[0] << "\t" << "[0] CGrandChild::CChild_a::CParent::vfptr->" << endl;

#if defined(OM_COMPILER_MSVC_)
  for (int i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   pFun();
  }
#else
  for (i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL && pVTable[0][i] > -100 && pVTable[0][i] < 100; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   pFun();
  }
  cout << "\t\t\t["<<i<<"] " << "\t" << &pVTable[0][i] << "\t" <<(int)pVTable[0][i] << endl;
#endif
  cout << (int*)&pVTable[1] << "\t" << "[1] CParent.iparent_ = " << (int)pVTable[1] << endl;
  cout << (int*)&pVTable[2] << "\t" << "[2] CGrandChild::CChild_a.ichild_ = " << (int)pVTable[2] << endl;
  cout << (int*)&pVTable[3] << "\t" << "[3] CGrandChild::CChild_b::CParent::vfptr->" << endl;
  for (int i = 0; (Ptr_Void_Fun)pVTable[3][i] != NULL; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[3][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[3][i];
   pFun();
  }

  cout << (int*)&pVTable[4] << "\t" << "[4] CParent.iparent_ = " << (int)pVTable[4] << endl;
  cout << (int*)&pVTable[5] << "\t" << "[5] CGrandChild::CChild_b.ichild_ = " << (int)pVTable[5] << endl;
  cout << (int*)&pVTable[6] << "\t" << "[6] CGrandChild::ichild_ = " << (int)pVTable[6] << endl;

  cout << endl << "--------------- Test CGrandChild_v" << endl;
  CGrandChild_v cgcv;
  pVTable = (int**)&cgcv;
  cout << "size: " << sizeof(cgcv) << endl;
  cout << (int*)&pVTable[0] << "\t" << "[0] CGrandChild_v::CChild_av::vfptr->" << endl;
#if defined(OM_COMPILER_MSVC_)
  for (int i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   pFun();
  }
#else
  for (int i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL && pVTable[0][i] > -100 && pVTable[0][i] < 100; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   pFun();
  }
  cout << "\t\t\t["<<i<<"] " << "\t" << &pVTable[0][i] << "\t" <<(int)pVTable[0][i] << endl;
#endif

#if defined(OM_COMPILER_MSVC_)
  cout << (int*)&pVTable[1] << "\t" << "[1] CGrandChild_v::CChild_av::vbptr" << endl;
  cout << "\t\t\t" << "[0] CChild_b::vbptr for CChild_av  (" << &pVTable[1][0] << ")  = " <<pVTable[1][0]<< endl;
  cout << "\t\t\t" << "[1] CChild_b::vbptr for CParent    (" << &pVTable[1][1] << ")  = " <<pVTable[1][1]<< endl;

   cout << (int*)&pVTable[2] << "\t" << "[2] CGrandChild::CChild_av.ichild_ = " << (int)pVTable[2] << endl;

   cout << (int*)&pVTable[3] << "\t" << "[3] CGrandChild_v::CChild_bv::vfptr->" << endl;
   for (int i = 0; (Ptr_Void_Fun)pVTable[3][i] != NULL; i++) {
    cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[3][i]<<"\t";
    pFun = (Ptr_Void_Fun)pVTable[3][i];
    pFun();
   }
   cout << (int*)&pVTable[4] << "\t" << "[1] CGrandChild_v::CChild_bv::vbptr" << endl;
   cout << "\t\t\t" << "[0] CChild_b::vbptr for CChild_bv  (" << &pVTable[4][0] << ")  = " <<pVTable[4][0]<< endl;
   cout << "\t\t\t" << "[1] CChild_b::vbptr for CParent    (" << &pVTable[4][1] << ")  = " <<pVTable[4][1]<< endl;

   cout << (int*)&pVTable[5] << "\t" << "[5] CGrandChild::CChild_bv.ichild_ = " << (int)pVTable[5] << endl;
   cout << (int*)&pVTable[6] << "\t" << "[6] CGrandChild::ichild_ = " << (int)pVTable[6] << endl;

   cout << (int*)&pVTable[7] << "\t" << "[7] CParent::vfptr->" << endl;
   for (int i = 0; (Ptr_Void_Fun)pVTable[7][i] != NULL; i++) {
    cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[7][i]<<"\t";
    pFun = (Ptr_Void_Fun)pVTable[7][i];
    pFun();
   }
   cout << (int*)&pVTable[8] << "\t" << "[8] CParent::iparent_ = " << (int)pVTable[8] << endl;
#else
   cout << (int*)&pVTable[1] << "\t" << "[1] CGrandChild::CChild_av.ichild_ = " << (int)pVTable[1] << endl;

   cout << (int*)&pVTable[2] << "\t" << "[2] CGrandChild_v::CChild_bv::vfptr->" << endl;
   for (int i = 0; (Ptr_Void_Fun)pVTable[2][i] != NULL && pVTable[2][i] > -100 && pVTable[2][i] < 100; i++) {
    cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[2][i]<<"\t";
    pFun = (Ptr_Void_Fun)pVTable[2][i];
    pFun();
   }
   cout << "\t\t\t["<<i<<"] " << "\t" << &pVTable[0][i] << "\t" <<(int)pVTable[0][i] << endl;
   cout << (int*)&pVTable[3] << "\t" << "[3] CGrandChild::CChild_bv.ichild_ = " << (int)pVTable[3] << endl;
   cout << (int*)&pVTable[4] << "\t" << "[4] CGrandChild::ichild_ = " << (int)pVTable[4] << endl;
   cout << (int*)&pVTable[5] << "\t" << "[5] CParent::vfptr->" << endl;
   for (int i = 0; (Ptr_Void_Fun)pVTable[5][i] != NULL; i++) {
    cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[5][i]<<"\t";
    pFun = (Ptr_Void_Fun)pVTable[5][i];
    pFun();
   }
   cout << (int*)&pVTable[6] << "\t" << "[8] CParent::iparent_ = " << (int)pVTable[8] << endl;
#endif
 }
}

#endif
